## olive-editor 20190502

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9 FATAL_ERROR)

project(olive-editor LANGUAGES CXX)

option(BUILD_DOXYGEN "Build Doxygen documentation" OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(OLIVE_DEFINITIONS -DQT_DEPRECATED_WARNINGS)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(UNIX AND NOT APPLE AND NOT DEFINED OpenGL_GL_PREFERENCE)
  set(OpenGL_GL_PREFERENCE LEGACY)
endif()
find_package(OpenGL REQUIRED)

find_package(Qt5 5.7 REQUIRED
  COMPONENTS
  Core
  Gui
  Widgets
  Multimedia
  OpenGL
  Svg
  LinguistTools
)

find_package(FFMPEG 3.4 REQUIRED
  COMPONENTS
  avutil
  avcodec
  avformat
  avfilter
  swscale
  swresample
)

find_package(frei0r)
if(NOT FREI0R_FOUND)
  list(APPEND OLIVE_DEFINITIONS -DNOFREI0R)
endif()

if(WIN32)
  find_package(OpenColorIO)
  if(OPENCOLORIO_FOUND)
    list(APPEND OLIVE_DEFINITIONS -DOLIVE_OCIO)
  endif()
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} log -1 --format=%h
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE GIT_HASH
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  endif()
elseif(UNIX AND NOT APPLE)
  # Fallback for Ubuntu/Launchpad (extracts Git hash from debian/changelog rather than Git repo)
  # (see https://answers.launchpad.net/launchpad/+question/678556)
  execute_process(COMMAND sh -c "grep -Po '(?<=-)(([a-z0-9])\\w+)(?=\\+)' -m 1 changelog"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/debian
    OUTPUT_VARIABLE GIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()
if(DEFINED GIT_HASH)
  message("Olive: git hash = " "${GIT_HASH}")
  list(APPEND OLIVE_DEFINITIONS -DGITHASH="${GIT_HASH}")
else()
  message("Olive: No git hash defined!")
endif()

find_package(Doxygen)

set(OLIVE_SOURCES
  dialogs/aboutdialog.cpp
  dialogs/aboutdialog.h
  dialogs/actionsearch.cpp
  dialogs/actionsearch.h
  dialogs/advancedvideodialog.cpp
  dialogs/advancedvideodialog.h
  dialogs/autocutsilencedialog.cpp
  dialogs/autocutsilencedialog.h
  dialogs/clippropertiesdialog.cpp
  dialogs/clippropertiesdialog.h
  dialogs/debugdialog.cpp
  dialogs/debugdialog.h
  dialogs/demonotice.cpp
  dialogs/demonotice.h
  dialogs/exportdialog.cpp
  dialogs/exportdialog.h
  dialogs/loaddialog.cpp
  dialogs/loaddialog.h
  dialogs/mediapropertiesdialog.cpp
  dialogs/mediapropertiesdialog.h
  dialogs/newsequencedialog.cpp
  dialogs/newsequencedialog.h
  dialogs/preferencesdialog.cpp
  dialogs/preferencesdialog.h
  dialogs/proxydialog.cpp
  dialogs/proxydialog.h
  dialogs/replaceclipmediadialog.cpp
  dialogs/replaceclipmediadialog.h
  dialogs/speeddialog.cpp
  dialogs/speeddialog.h
  dialogs/texteditdialog.cpp
  dialogs/texteditdialog.h
  effects/fields/boolfield.cpp
  effects/fields/boolfield.h
  effects/fields/buttonfield.cpp
  effects/fields/buttonfield.h
  effects/fields/colorfield.cpp
  effects/fields/colorfield.h
  effects/fields/combofield.cpp
  effects/fields/combofield.h
  effects/fields/doublefield.cpp
  effects/fields/doublefield.h
  effects/fields/filefield.cpp
  effects/fields/filefield.h
  effects/fields/fontfield.cpp
  effects/fields/fontfield.h
  effects/fields/labelfield.cpp
  effects/fields/labelfield.h
  effects/fields/stringfield.cpp
  effects/fields/stringfield.h
  effects/internal/audionoiseeffect.cpp
  effects/internal/audionoiseeffect.h
  effects/internal/blending.frag
  effects/internal/common.vert
  effects/internal/cornerpin.frag
  effects/internal/cornerpin.vert
  effects/internal/cornerpineffect.cpp
  effects/internal/cornerpineffect.h
  effects/internal/crossdissolvetransition.cpp
  effects/internal/crossdissolvetransition.h
  effects/internal/cubetransition.h
  effects/internal/dropshadow.frag
  effects/internal/dropshadoweffect.cpp
  effects/internal/dropshadoweffect.h
  effects/internal/exponentialfadetransition.cpp
  effects/internal/exponentialfadetransition.h
  effects/internal/fillleftrighteffect.cpp
  effects/internal/fillleftrighteffect.h
  effects/internal/frei0reffect.cpp
  effects/internal/frei0reffect.h
  effects/internal/internalshaders.qrc
  effects/internal/linearfadetransition.cpp
  effects/internal/linearfadetransition.h
  effects/internal/logarithmicfadetransition.cpp
  effects/internal/logarithmicfadetransition.h
  effects/internal/ocio.frag
  effects/internal/paneffect.cpp
  effects/internal/paneffect.h
  effects/internal/premultiply.frag
  effects/internal/richtexteffect.cpp
  effects/internal/richtexteffect.h
  effects/internal/shakeeffect.cpp
  effects/internal/shakeeffect.h
  effects/internal/solideffect.cpp
  effects/internal/solideffect.h
  effects/internal/texteffect.cpp
  effects/internal/texteffect.h
  effects/internal/timecodeeffect.cpp
  effects/internal/timecodeeffect.h
  effects/internal/toneeffect.cpp
  effects/internal/toneeffect.h
  effects/internal/transformeffect.cpp
  effects/internal/transformeffect.h
  effects/internal/voideffect.cpp
  effects/internal/voideffect.h
  effects/internal/volumeeffect.cpp
  effects/internal/volumeeffect.h
  effects/internal/vsthost.cpp
  effects/internal/vsthost.h
  effects/effect.cpp
  effects/effect.h
  effects/effectfield.cpp
  effects/effectfield.h
  effects/effectfields.h
  effects/effectgizmo.cpp
  effects/effectgizmo.h
  effects/effectloaders.cpp
  effects/effectloaders.h
  effects/effectrow.cpp
  effects/effectrow.h
  effects/keyframe.cpp
  effects/keyframe.h
  effects/transition.cpp
  effects/transition.h
  global/config.cpp
  global/config.h
  global/debug.cpp
  global/debug.h
  global/global.cpp
  global/global.h
  global/math.cpp
  global/math.h
  global/path.cpp
  global/path.h
  include/vestige.h
  panels/effectcontrols.cpp
  panels/effectcontrols.h
  panels/grapheditor.cpp
  panels/grapheditor.h
  panels/panels.cpp
  panels/panels.h
  panels/project.cpp
  panels/project.h
  panels/timeline.cpp
  panels/timeline.h
  panels/viewer.cpp
  panels/viewer.h
  project/clipboard.cpp
  project/clipboard.h
  project/footage.cpp
  project/footage.h
  project/loadthread.cpp
  project/loadthread.h
  project/media.cpp
  project/media.h
  project/previewgenerator.cpp
  project/previewgenerator.h
  project/projectelements.h
  project/projectfilter.cpp
  project/projectfilter.h
  project/projectmodel.cpp
  project/projectmodel.h
  project/proxygenerator.cpp
  project/proxygenerator.h
  project/sourcescommon.cpp
  project/sourcescommon.h
  rendering/audio.cpp
  rendering/audio.h
  rendering/cacher.cpp
  rendering/cacher.h
  rendering/clipqueue.cpp
  rendering/clipqueue.h
  rendering/exportthread.cpp
  rendering/exportthread.h
  rendering/framebufferobject.cpp
  rendering/framebufferobject.h
  rendering/renderfunctions.cpp
  rendering/renderfunctions.h
  rendering/renderthread.cpp
  rendering/renderthread.h
  timeline/clip.cpp
  timeline/clip.h
  timeline/marker.cpp
  timeline/marker.h
  timeline/mediaimportdata.cpp
  timeline/mediaimportdata.h
  timeline/selection.h
  timeline/sequence.cpp
  timeline/sequence.h
  ui/audiomonitor.cpp
  ui/audiomonitor.h
  ui/blur.cpp
  ui/blur.h
  ui/clickablelabel.cpp
  ui/clickablelabel.h
  ui/collapsiblewidget.cpp
  ui/collapsiblewidget.h
  ui/columnedgridlayout.cpp
  ui/columnedgridlayout.h
  ui/colorbutton.cpp
  ui/colorbutton.h
  ui/comboboxex.cpp
  ui/comboboxex.h
  ui/cursors.cpp
  ui/cursors.h
  ui/effectui.cpp
  ui/effectui.h
  ui/embeddedfilechooser.cpp
  ui/embeddedfilechooser.h
  ui/flowlayout.cpp
  ui/flowlayout.h
  ui/focusfilter.cpp
  ui/focusfilter.h
  ui/fontcombobox.cpp
  ui/fontcombobox.h
  ui/graphview.cpp
  ui/graphview.h
  ui/icons.cpp
  ui/icons.h
  ui/keyframedrawing.cpp
  ui/keyframedrawing.h
  ui/keyframenavigator.cpp
  ui/keyframenavigator.h
  ui/keyframeview.cpp
  ui/keyframeview.h
  ui/labelslider.cpp
  ui/labelslider.h
  ui/mainwindow.cpp
  ui/mainwindow.h
  ui/mediaiconservice.cpp
  ui/mediaiconservice.h
  ui/menu.cpp
  ui/menu.h
  ui/menuhelper.cpp
  ui/menuhelper.h
  ui/panel.cpp
  ui/panel.h
  ui/playbutton.cpp
  ui/playbutton.h
  ui/rectangleselect.cpp
  ui/rectangleselect.h
  ui/resizablescrollbar.cpp
  ui/resizablescrollbar.h
  ui/scrollarea.cpp
  ui/scrollarea.h
  ui/sourceiconview.cpp
  ui/sourceiconview.h
  ui/sourcetable.cpp
  ui/sourcetable.h
  ui/styling.cpp
  ui/styling.h
  ui/texteditex.cpp
  ui/texteditex.h
  ui/timelineheader.cpp
  ui/timelineheader.h
  ui/timelinetools.h
  ui/timelinewidget.cpp
  ui/timelinewidget.h
  ui/updatenotification.cpp
  ui/updatenotification.h
  ui/viewercontainer.cpp
  ui/viewercontainer.h
  ui/viewerwidget.cpp
  ui/viewerwidget.h
  ui/viewerwindow.cpp
  ui/viewerwindow.h
  undo/comboaction.cpp
  undo/comboaction.h
  undo/undo.cpp
  undo/undo.h
  undo/undostack.cpp
  undo/undostack.h
  main.cpp
)

set(OLIVE_RESOURCES
  cursors/cursors.qrc
  effects/internal/internalshaders.qrc
  icons/icons.qrc
)

set(OLIVE_EFFECTS
  effects/shaders/boxblur.frag
  effects/shaders/boxblur.xml
  effects/shaders/bulge.frag
  effects/shaders/bulge.xml
  effects/shaders/chromakey.frag
  effects/shaders/chromakey.xml
  effects/shaders/chromaticaberration.frag
  effects/shaders/chromaticaberration.xml
  effects/shaders/colorcorrection.frag
  effects/shaders/colorcorrection.xml
  effects/shaders/colorsel.frag
  effects/shaders/colorsel.xml
  effects/shaders/common.frag
  effects/shaders/common.vert
  effects/shaders/crop.frag
  effects/shaders/crop.xml
  effects/shaders/crossstitch.frag
  effects/shaders/crossstitch.xml
  effects/shaders/directionalblur.frag
  effects/shaders/directionalblur.xml
  effects/shaders/dropshadow.xml.disabled
  effects/shaders/emboss.frag
  effects/shaders/emboss.xml
  effects/shaders/findedges.frag
  effects/shaders/findedges.xml.disabled
  effects/shaders/fisheye.frag
  effects/shaders/fisheye.xml
  effects/shaders/flip.frag
  effects/shaders/flip.xml
  effects/shaders/gaussianblur.frag
  effects/shaders/gaussianblur.xml
  effects/shaders/huesatbri.frag
  effects/shaders/huesatbri.xml
  effects/shaders/invert.frag
  effects/shaders/invert.xml
  effects/shaders/lumakey.frag
  effects/shaders/lumakey.xml
  effects/shaders/noise.frag
  effects/shaders/noise.xml
  effects/shaders/pixelate.frag
  effects/shaders/pixelate.xml
  effects/shaders/posterize.frag
  effects/shaders/posterize.xml
  effects/shaders/radialblur.frag
  effects/shaders/radialblur.xml
  effects/shaders/ripple.frag
  effects/shaders/ripple.xml
  effects/shaders/sphere.frag
  effects/shaders/sphere.xml
  effects/shaders/swirl.frag
  effects/shaders/swirl.xml
  effects/shaders/tile.frag
  effects/shaders/tile.xml
  effects/shaders/toonify.frag
  effects/shaders/toonify.xml
  effects/shaders/vignette.frag
  effects/shaders/vignette.xml
  effects/shaders/volumetriclight.frag
  effects/shaders/volumetriclight.xml
  effects/shaders/wave.frag
  effects/shaders/wave.xml
)

qt5_add_translation(OLIVE_QM_FILES
  ts/olive_ar.ts
  ts/olive_bs.ts
  ts/olive_cs.ts
  ts/olive_de.ts
  ts/olive_es.ts
  ts/olive_fr.ts
  ts/olive_it.ts
  ts/olive_ru.ts
  ts/olive_sr.ts
  ts/olive_id.ts
)

set(OLIVE_TARGET "olive-editor")
if(APPLE)
  set(OLIVE_TARGET "Olive")
endif()

add_executable(${OLIVE_TARGET}
  ${OLIVE_SOURCES}
  ${OLIVE_RESOURCES}
  ${OLIVE_EFFECTS}
  ${OLIVE_QM_FILES}
)

target_compile_definitions(${OLIVE_TARGET} PRIVATE ${OLIVE_DEFINITIONS})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

target_link_libraries(${OLIVE_TARGET}
  PRIVATE
  OpenGL::GL
  Qt5::Core
  Qt5::Gui
  Qt5::Widgets
  Qt5::Multimedia
  Qt5::OpenGL
  Qt5::Svg
  FFMPEG::avutil
  FFMPEG::avcodec
  FFMPEG::avformat
  FFMPEG::avfilter
  FFMPEG::swscale
  FFMPEG::swresample
)

if(WIN32 AND OPENCOLORIO_FOUND)
  target_link_libraries(${OLIVE_TARGET} PRIVATE OpenColorIO)
endif()

if(DOXYGEN_FOUND AND BUILD_DOXYGEN)
  set(DOXYGEN_PROJECT_NAME "Olive")
  set(DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/docs")
  set(DOXYGEN_EXTRACT_ALL "YES")
  set(DOXYGEN_EXTRACT_PRIVATE "YES")
  doxygen_add_docs(docs ALL ${OLIVE_SOURCES})

## olive-editor 20181223

=== debian/changelog ===
olive-editor (20181223-1) unstable; urgency=medium

  * debian/control: add optional frei0or plugins.
  * Rename source and binary package name to olive-editor.
  * Add to Multimedia team.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 03 Jan 2019 06:54:45 +0100

olive (20181223-1) unstable; urgency=medium

  * New upstream version.
  * debian/copyright: complete attribution. (Closes: #917300)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 26 Dec 2018 14:41:24 +0100

olive (20181130-1) unstable; urgency=medium

  * Initial release. (Closes: #917170)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 21 Dec 2018 12:02:12 +0100

=== debian/control ===
Source: olive-editor
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), qtmultimedia5-dev, libqt5multimedia5-plugins, libavfilter-dev, dh-exec, libqt5opengl5-dev, frei0r-plugins-dev
Standards-Version: 4.2.1
Homepage: https://www.olivevideoeditor.org/

Package: olive-editor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, frei0r-plugins
Replaces: olive (<< 20181223-2)
Breaks: olive (<< 20181223-2)
Description: Professional open-source NLE video editor
 This is a free non-linear video editor.

## olive-editor 20181223+qtbuild

=== debian/changelog ===
olive-editor (20181223+qtbuild-1+eagle) unstable; urgency=medium

  * update

 -- Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>  Tue, 26 Jan 2021 20:28:58 +0800

olive-editor (20181223-2) unstable; urgency=medium

  * debian/control:
    - drop conflicts/replaces. (Closes: #921729)
    - improve long description.
  * add QList QPainterPath header.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 25 Feb 2019 10:24:30 +0100

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

%:
	dh $@

override_dh_auto_configure:
	qmake -makefile PREFIX=$(shell pwd)/olive/usr olive.pro
	sed -i "s,-DQT_NO_DEBUG,,g" Makefile
	sed -i 's/^CXXFLAGS.*/& -g/g' Makefile

## olive-editor 20190502

=== debian/changelog ===
olive-editor (20190502-3) unstable; urgency=medium

  * Add missing depends. (Closes: #932502)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 05 Aug 2019 13:33:55 +0200

olive-editor (20190502-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 07 Jul 2019 12:25:38 +0200

olive-editor (20190502-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 05 Jun 2019 13:50:40 +0200

=== debian/control ===
Source: olive-editor
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), qtmultimedia5-dev, libqt5multimedia5-plugins, libavfilter-dev, libqt5opengl5-dev, frei0r-plugins-dev, libqt5opengl5-dev, libqt5svg5-dev,  libavformat-dev, libavcodec-dev, libavutil-dev, libswscale-dev, libswresample-dev, libpostproc-dev, cmake, qttools5-dev
Standards-Version: 4.2.1
Homepage: https://www.olivevideoeditor.org/

Package: olive-editor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, frei0r-plugins, libqt5multimedia5-plugins
Description: Professional open-source NLE video editor
 This is a free non-linear video editor. It provides sensible cutting tools,
 and basic FX animation. There are solic color and title generators, for cutting
 it has tools like Razor, Ripple, Slide, and Slip.

## olive-editor 20191111

=== CMakeLists.txt ===
--- 
+++ 
@@ -428,6 +428,11 @@
   ts/olive_ru.ts
   ts/olive_sr.ts
   ts/olive_id.ts
+  ts/olive_tr.ts
+  ts/olive_pt-BR.ts
+  ts/olive_uk.ts
+  ts/olive_zh-CN.ts
+  ts/olive_zh-TW.ts
 )
 
 set(OLIVE_TARGET "olive-editor")
@@ -470,6 +475,3 @@
 if(DOXYGEN_FOUND AND BUILD_DOXYGEN)
   set(DOXYGEN_PROJECT_NAME "Olive")
   set(DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/docs")
-  set(DOXYGEN_EXTRACT_ALL "YES")
-  set(DOXYGEN_EXTRACT_PRIVATE "YES")
-  doxygen_add_docs(docs ALL ${OLIVE_SOURCES})

=== debian/changelog ===
olive-editor (20191111-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.4.1.
  * Add Vcs fields.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 12 Nov 2019 10:23:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: olive-editor
 Section: video
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
 Build-Depends: debhelper (>= 11), qtmultimedia5-dev, libqt5multimedia5-plugins, libavfilter-dev, libqt5opengl5-dev, frei0r-plugins-dev, libqt5opengl5-dev, libqt5svg5-dev,  libavformat-dev, libavcodec-dev, libavutil-dev, libswscale-dev, libswresample-dev, libpostproc-dev, cmake, qttools5-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.1
+Vcs-Git: https://salsa.debian.org/multimedia-team/olive-editor.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/olive-editor
 Homepage: https://www.olivevideoeditor.org/
 
 Package: olive-editor

## olive-editor 20200210

=== CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.9 FATAL_ERROR)

project(olive-editor VERSION 0.2.0 LANGUAGES CXX)

option(UPDATE_TS "Update translations" OFF)
option(BUILD_DOXYGEN "Build Doxygen documentation" OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(OLIVE_DEFINITIONS -DAPPVERSION="${PROJECT_VERSION}" -DQT_DEPRECATED_WARNINGS)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(UNIX AND NOT APPLE AND NOT DEFINED OpenGL_GL_PREFERENCE)
  set(OpenGL_GL_PREFERENCE LEGACY)
endif()

find_package(OpenGL REQUIRED)

find_package(OpenColorIO REQUIRED)

find_package(OpenImageIO REQUIRED)

find_package(Qt5 5.6 REQUIRED
  COMPONENTS
  Core
  Gui
  Widgets
  Multimedia
  OpenGL
  Svg
  LinguistTools
)

find_package(FFMPEG 3.0 REQUIRED
  COMPONENTS
  avutil
  avcodec
  avformat
  avfilter
  swscale
  swresample
)

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} log -1 --format=%h
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE GIT_HASH
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  endif()
elseif(UNIX AND NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
  # Fallback for Ubuntu/Launchpad (extracts Git hash from debian/changelog rather than Git repo)
  # (see https://answers.launchpad.net/launchpad/+question/678556)
  execute_process(COMMAND sh -c "grep -Po '(?<=-)(([a-z0-9])\\w+)(?=\\+)' -m 1 changelog"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/debian
    OUTPUT_VARIABLE GIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()
if(DEFINED GIT_HASH)
  message("Olive: Git hash = " "${GIT_HASH}")
  list(APPEND OLIVE_DEFINITIONS -DGITHASH="${GIT_HASH}")
else()
  message("Olive: No Git hash defined!")
endif()

if(BUILD_DOXYGEN)
  find_package(Doxygen)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(app)

=== app/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  core.h
  core.cpp
  main.cpp
)

set(OLIVE_RESOURCES
  ${OLIVE_RESOURCES}
)

add_subdirectory(audio)
add_subdirectory(codec)
add_subdirectory(common)
add_subdirectory(config)
add_subdirectory(dialog)
add_subdirectory(node)
add_subdirectory(panel)
add_subdirectory(project)
add_subdirectory(render)
add_subdirectory(shaders)
add_subdirectory(task)
add_subdirectory(timeline)
add_subdirectory(tool)
add_subdirectory(ui)
add_subdirectory(undo)
add_subdirectory(widget)
add_subdirectory(window)

set(OLIVE_TARGET "olive-editor")
if(APPLE)
  set(OLIVE_TARGET "Olive")
endif()

add_executable(${OLIVE_TARGET}
  ${OLIVE_SOURCES}
  ${OLIVE_RESOURCES}
  ${OLIVE_QM_FILES}
)

if(APPLE)
  SET_TARGET_PROPERTIES(${OLIVE_TARGET} PROPERTIES
    MACOSX_BUNDLE TRUE
    MACOSX_FRAMEWORK_IDENTIFIER org.olivevideoeditor.Olive
  )
endif()

target_compile_definitions(${OLIVE_TARGET} PRIVATE ${OLIVE_DEFINITIONS})

if(MSVC)
  target_compile_options(
    ${OLIVE_TARGET}
    PRIVATE
    /WX
    /W4
    /wd4127
    /wd4456
    /wd4706
    /experimental:external
    /external:anglebrackets
    /external:W0
    "$<$<CONFIG:RELEASE>:/O2>"
  )
else()
  target_compile_options(${OLIVE_TARGET} PRIVATE -O2 -Werror -Wuninitialized -pedantic-errors -Wall -Wextra -Wconversion -Wsign-conversion)
endif()

target_include_directories(
  ${OLIVE_TARGET}
  PRIVATE
  ${OPENCOLORIO_INCLUDE_DIR}
  ${OIIO_INCLUDE_DIRS}
  ${FFMPEG_INCLUDE_DIRS}
)

target_link_libraries(${OLIVE_TARGET}
  PRIVATE
  OpenGL::GL
  Qt5::Core
  Qt5::Gui
  Qt5::Widgets
  Qt5::Multimedia
  Qt5::OpenGL
  Qt5::Svg
  FFMPEG::avutil
  FFMPEG::avcodec
  FFMPEG::avformat
  FFMPEG::avfilter
  FFMPEG::swscale
  FFMPEG::swresample
  ${OCIO_LIBRARIES}
  ${OIIO_LIBRARIES}
)

set(OLIVE_TS_FILES
  # FIXME: Empty variable
)

if(UPDATE_TS)
  qt5_create_translation(OLIVE_QM_FILES ${CMAKE_SOURCE_DIR} ${OLIVE_TS_FILES})
else()
  qt5_add_translation(OLIVE_QM_FILES ${OLIVE_TS_FILES})
endif()

if(UNIX AND NOT APPLE)
  install(TARGETS ${OLIVE_TARGET} RUNTIME DESTINATION bin)
  install(FILES ${OLIVE_QM_FILES} DESTINATION share/olive-editor/ts)
endif()

add_subdirectory(packaging)

if(DOXYGEN_FOUND)
  set(DOXYGEN_PROJECT_NAME "Olive")
  set(DOXYGEN_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/docs")
  set(DOXYGEN_EXTRACT_ALL "YES")
  set(DOXYGEN_EXTRACT_PRIVATE "YES")
  doxygen_add_docs(docs ALL ${OLIVE_SOURCES})
endif()

=== app/audio/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  audio/audiomanager.h
  audio/audiomanager.cpp
  audio/bufferaverage.h
  audio/bufferaverage.cpp
  audio/outputdeviceproxy.h
  audio/outputdeviceproxy.cpp
  audio/outputmanager.h
  audio/outputmanager.cpp
  audio/sampleformat.h
  audio/sampleformat.cpp
  audio/tempoprocessor.h
  audio/tempoprocessor.cpp
  PARENT_SCOPE
)

=== app/codec/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(ffmpeg)
add_subdirectory(oiio)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  codec/decoder.h
  codec/decoder.cpp
  codec/encoder.h
  codec/encoder.cpp
  codec/frame.h
  codec/frame.cpp
  codec/waveinput.h
  codec/waveinput.cpp
  codec/waveoutput.h
  codec/waveoutput.cpp
  PARENT_SCOPE
)

=== app/common/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  common/bezier.h
  common/bezier.cpp
  common/channellayout.h
  common/clamp.h
  common/constructors.h
  common/debug.h
  common/debug.cpp
  common/define.h
  common/filefunctions.h
  common/filefunctions.cpp
  common/flipmodifiers.h
  common/flipmodifiers.cpp
  common/lerp.h
  common/qtversionabstraction.h
  common/qtversionabstraction.cpp
  common/range.h
  common/rational.h
  common/rational.cpp
  common/threadedobject.h
  common/threadedobject.cpp
  common/timecodefunctions.h
  common/timecodefunctions.cpp
  common/timelinecommon.h
  common/timerange.h
  common/timerange.cpp
  PARENT_SCOPE
)

=== app/dialog/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(about)
add_subdirectory(actionsearch)
add_subdirectory(export)
add_subdirectory(footageproperties)
add_subdirectory(keyframeproperties)
add_subdirectory(loadsave)
add_subdirectory(preferences)
add_subdirectory(projectproperties)
add_subdirectory(rendercancel)
add_subdirectory(sequence)
add_subdirectory(speedduration)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  PARENT_SCOPE
)

=== app/node/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(audio)
add_subdirectory(block)
add_subdirectory(distort)
add_subdirectory(input)
add_subdirectory(output)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  node/dependency.h
  node/dependency.cpp
  node/edge.h
  node/edge.cpp
  node/external.h
  node/external.cpp
  node/factory.h
  node/factory.cpp
  node/graph.h
  node/graph.cpp
  node/input.h
  node/input.cpp
  node/inputarray.h
  node/inputarray.cpp
  node/keyframe.h
  node/keyframe.cpp
  node/metareader.h
  node/metareader.cpp
  node/node.h
  node/node.cpp
  node/output.h
  node/output.cpp
  node/param.h
  node/param.cpp
  node/value.h
  node/value.cpp
  PARENT_SCOPE
)

=== app/panel/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(audiomonitor)
add_subdirectory(curve)
add_subdirectory(footageviewer)
add_subdirectory(node)
add_subdirectory(param)
add_subdirectory(project)
add_subdirectory(taskmanager)
add_subdirectory(timebased)
add_subdirectory(timeline)
add_subdirectory(tool)
add_subdirectory(viewer)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  panel/panelmanager.h
  panel/panelmanager.cpp
  PARENT_SCOPE
)

=== app/project/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(item)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  project/project.h
  project/project.cpp
  project/projectimportmanager.h
  project/projectimportmanager.cpp
  project/projectloadmanager.h
  project/projectloadmanager.cpp
  project/projectsavemanager.h
  project/projectsavemanager.cpp
  project/projectviewmodel.h
  project/projectviewmodel.cpp
  PARENT_SCOPE
)

=== app/render/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(backend)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  render/audioparams.h
  render/audioparams.cpp
  render/colormanager.h
  render/colormanager.cpp
  render/colorprocessor.h
  render/colorprocessor.cpp
  render/diskmanager.h
  render/diskmanager.cpp
  render/pixelformat.h
  render/pixelformat.cpp
  render/pixelservice.h
  render/pixelservice.cpp
  render/rendermodes.h
  render/videoparams.h
  render/videoparams.cpp
  PARENT_SCOPE
)

=== app/shaders/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(OLIVE_RESOURCES
  ${OLIVE_RESOURCES}
  shaders/shaders.qrc
  PARENT_SCOPE
)

=== app/task/CMakeLists.txt ===
# Olive - Non-Linear Video Editor
# Copyright (C) 2019 Olive Team
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(index)

set(OLIVE_SOURCES
  ${OLIVE_SOURCES}
  task/task.h
  task/task.cpp
  task/taskmanager.h
  task/taskmanager.cpp
  PARENT_SCOPE
)

=== debian/changelog ===
olive-editor (20200210-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Add requirements for at least Qt 5.9.
  * Run wrap-and-sort on the debian folder.
  * /debian: delete the install and the desktop files.
  * Add desktop-file.patch

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 16 Mar 2020 18:32:48 -0700

olive-editor (20200210-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.5.0.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 10 Feb 2020 13:43:47 +0100

olive-editor (20200121-1) unstable; urgency=medium

  * New upstream version.
  * d/control: Add libopencolorio-dev libopenimageio-dev to build-depends.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 21 Jan 2020 08:41:34 +0100

=== debian/control ===
Source: olive-editor
Section: video
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: cmake,
               debhelper (>= 11),
               frei0r-plugins-dev,
               libavcodec-dev,
               libavfilter-dev,
               libavformat-dev,
               libavutil-dev,
               libopencolorio-dev,
               libopenimageio-dev,
               libpostproc-dev,
               libqt5multimedia5-plugins (>= 5.9),
               libqt5opengl5-dev (>= 5.9),
               libqt5svg5-dev (>= 5.9),
               libswresample-dev,
               libswscale-dev,
               qtmultimedia5-dev (>= 5.9),
               qttools5-dev (>= 5.9)
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/multimedia-team/olive-editor.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/olive-editor
Homepage: https://www.olivevideoeditor.org/

Package: olive-editor
Architecture: any
Depends: ffmpeg,
         frei0r-plugins,
         libqt5multimedia5-plugins,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Professional open-source NLE video editor
 This is a free non-linear video editor. It provides sensible cutting tools,
 and basic FX animation. There are solic color and title generators, for cutting
 it has tools like Razor, Ripple, Slide, and Slip.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,5 @@
 %:
 	dh $@
 
-override_dh_auto_configure:
-	qmake -makefile PREFIX=$(shell pwd)/olive/usr olive.pro
-	sed -i "s,-DQT_NO_DEBUG,,g" Makefile
-	sed -i 's/^CXXFLAGS.*/& -g/g' Makefile
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
